
#include <stdio.h>
#include <stdlib.h>
#include "mt.h"

extern void	Error();

#define RATIO	0.0387420489	/* ==pow(9,9)/pow(10,10) */

static long	*Link;

static long	Trace(old)
long		old;
{
	long	new=Link[old];

	return (new<0)?old:(Link[old]=Trace(new));
}

static int	X,Y,Z;
static long	N,**LastZ,*LastY;

#define SITES	((double)X*(double)Y*(double)Z)

static void	RandomSitePercolation(p)
double		p;
{
	char	*tlc="too large cluster.";
	int	y,x,z,iy,ix;
	long	lastX,l,m,links=1,clusters=0;
	double	sites,total1=0.0,total2=0.0,largest=0.0;

#define CHECK(size)	if ((size)>=0) Error(tlc)

	for (y=0; y<Y; y++)
	for (x=0; x<X; x++) LastZ[y][x]=0;
	for (z=0; z<Z; z++) {
	  for (x=0; x<X; x++) LastY[x]=0;
	  for (y=0; y<Y; y++) {
	    lastX=0;
	    for (x=0; x<X; x++) {
	      if (MT_dRandom()>=p)
		l=0;

#include "c18.h"

	      else {
		if (links==N) {
		  for (iy=0; iy<Y; iy++)
		  for (ix=0; ix<X; ix++)
		    if ((l=LastZ[iy][ix])!=0) LastZ[iy][ix]=Trace(l);

		  for (ix=0; ix<X; ix++)
		    if ((l=LastY[ix])!=0) LastY[ix]=Trace(l);

		  for (links=l=1; l<N; l++)
		    if (Link[l]<0) ++links; else Link[l]=0;

		  if (links==N) Error("too many links.");
#ifdef	DEBUG
		  (void)fprintf(stderr,"%ld\n",links);
#endif
		  for (iy=0; iy<Y; iy++)
		  for (ix=0; ix<X; ix++)
		    if ((l=LastZ[iy][ix])!=0) {
		      LastZ[iy][ix]=Link[l];
		      Link[l]=(long)iy*(long)X+(long)ix+1;
		    }

		  for (ix=0; ix<X; ix++)
		    if ((l=LastY[ix])!=0) {
		      LastY[ix]=Link[l];
		      Link[l]=(long)Y*(long)X+(long)ix+1;
		    }

		  for (links=l=1; l<N; l++)
		    if ((m=Link[l])!=0) {
		      while (m>0) {
			ix=(int)((--m)%X);
			if ((iy=(int)(m/X))==Y) {
			  m=LastY[ix]; LastY[ix]=links;
			}
			else {
			  m=LastZ[iy][ix]; LastZ[iy][ix]=links;
			}
		      }
		      Link[links++]=m;
		    }
		}
		Link[l=links++]=(-1);
	      }
	      LastZ[y-1][x-1]=LastY[x-1]; LastY[x-1]=lastX; lastX=l;
	    }
	    LastZ[y-1][X-1]=LastY[X-1]; LastY[X-1]=lastX;
	  }
	  for (x=0; x<X; x++) LastZ[Y-1][x]=LastY[x];
	}
	for (l=1; l<links; l++)
	    if ((sites=(-(double)Link[l]))>0.0) {
		++clusters; total1+=sites; total2+=(sites*sites);
		if (sites>largest) largest=sites;
	    }

	(void)printf("%lf\t%ld\t%ld\t",total1/SITES,links,clusters);
	if (clusters==0)
	    (void)puts("0\t0");
	else
	    (void)printf("%lf\t%lf\n",
			 largest/total1,(total2-largest*largest)/total1);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	double		links,p;
	unsigned	seed;
	int		x,y;

	if (argc<5)
	    Error("usage : c18 sites_x sites_y sites_z seed {probabilities}");

	if ((X=atoi(*(++argv)))<=0 ||
	    (Y=atoi(*(++argv)))<=0 ||
	    (Z=atoi(*(++argv)))<=0 ||
	    (links=RATIO*SITES)>=(double)((size_t)(~0)/sizeof(long)) ||
	    (N=(long)(links+1.0))<=0) Error("bad number of sites.");

	if (sscanf(*(++argv),"%u",&seed)!=1 || seed==0)
	    Error("bad random number seed.");

#define ALLOC(type,size)	(type *)malloc(sizeof(type)*(size))

	if ((Link=ALLOC(long,(size_t)N))==NULL ||
	    (LastZ=ALLOC(long *,(size_t)(Y+2)))==NULL ||
	    (LastZ[0]=ALLOC(long,(size_t)(Y+2)*(size_t)(X+2)))==NULL ||
	    (LastY=ALLOC(long,(size_t)(X+2)))==NULL)
	    Error("memory allocation error.");

	++LastZ;
	++LastZ[-1]; for (x=(-1); x<=X; x++) LastZ[-1][x]=0;
	for (y=0; y<Y; y++) {
	    LastZ[y]=LastZ[y-1]+X+2; LastZ[y][-1]=LastZ[y][X]=0;
	}
	LastZ[Y]=LastZ[Y-1]+X+2; for (x=(-1); x<=X; x++) LastZ[Y][x]=0;

	++LastY; LastY[-1]=LastY[X]=0;

	MT_sRandom(seed);

	if (argc==5)
	    while (scanf("%lf",&p)==1) RandomSitePercolation(p);
	else
	    while (--argc>=5) RandomSitePercolation(atof(*(++argv)));

	return 0;
}
