
#include <stdio.h>
#include <stdlib.h>
#include "mt.h"
#include "cell.h"
#include "sif.h"

extern void	Error(char *msg);

int	main(int argc,char **argv)
{
	int		Nx,Ny,y,x;
	unsigned int	seed;
	double		p;
	Cell		**cell;

	if (argc!=6) Error("usage : rs_2d Nx Ny seed p TIFF");

	if (sscanf(argv[1],"%d",&Nx)!=1 || Nx<=0 ||
	    sscanf(argv[2],"%d",&Ny)!=1 || Ny<=0 ||
	    sscanf(argv[3],"%u",&seed)!=1 || seed==0 ||
	    sscanf(argv[4],"%lf",&p)!=1 || p<0.0 || p>1.0)
	    Error("bad parameter(s).");

	if ((cell=(Cell **)malloc(sizeof(Cell *)*Ny))==NULL ||
	    (*cell=(Cell *)malloc(sizeof(Cell)*Ny*Nx))==NULL)
	    Error("memory allocation error.");

	MT_sRandom(seed);

	for (y=0; y<Ny; y++) {
	    if (y>0) cell[y]=cell[y-1]+Nx;

	    for (x=0; x<Nx; x++) cell[y][x]=MT_dRandom()<p;
	}
	StoreImageFile(argv[5],Nx,Ny,1,cell,NULL); return 0;
}
