
#include <stdio.h>
#include <stdlib.h>
#include "mt.h"
#include "cell.h"
#include "sif.h"

extern void	Error(char *msg);

#define LEN	1024

int	main(int argc,char **argv)
{
	int		Nx,Ny,Nz,y,len,z,x;
	unsigned int	seed;
	double		p;
	Cell		**cell;
	char		form[LEN],path[LEN];

	if (argc!=7) Error("usage : rs_3d Nx Ny Nz seed p directory");

	if (sscanf(argv[1],"%d",&Nx)!=1 || Nx<=0 ||
	    sscanf(argv[2],"%d",&Ny)!=1 || Ny<=0 ||
	    sscanf(argv[3],"%d",&Nz)!=1 || Nz<=0 ||
	    sscanf(argv[4],"%u",&seed)!=1 || seed==0 ||
	    sscanf(argv[5],"%lf",&p)!=1 || p<0.0 || p>1.0)
	    Error("bad parameter(s).");

	if ((cell=(Cell **)malloc(sizeof(Cell *)*Ny))==NULL ||
	    (*cell=(Cell *)malloc(sizeof(Cell)*Ny*Nx))==NULL)
	    Error("memory allocation error.");

	for (y=1; y<Ny; y++) cell[y]=cell[y-1]+Nx;

	len=1; for (z=10; z<Nz; z*=10) ++len;
	(void)sprintf(form,"%s/%%0%dd.tif",argv[6],len);

	MT_sRandom(seed);

	for (z=0; z<Nz; z++) {
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++) cell[y][x]=MT_dRandom()<p;

	    (void)sprintf(path,form,z);
	    StoreImageFile(path,Nx,Ny,1,cell,NULL);
	}
	return 0;
}
